from tqsi import *

general_svg="""

    <marker id="arrow" viewBox="0 0 10 10" refX="5" refY="5"
        markerWidth="6" markerHeight="6"
        orient="auto-start-reverse">
      <path d="M 0 0 L 10 5 L 0 10 z" />
    </marker>

"""

connecteur_vertical_svg="""
<line x1="{0}" y1="{1}" x2="{0}" y2="{2}" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>
"""
def connecteur(x,y):
    return connecteur_vertical_svg.format(x,y,y+30)

debut_svg="""

<g id="{0}">
<rect width="{1}" height="60" rx="20" fill="white" stroke="black"   />
<text font-size="12" font-family="arial"  fill="black">
<tspan x="20" y="22" font-weight="bold">
DEBUT :
</tspan>
<tspan x="20" y="42">
{2}
</tspan>
</text>
</g>

"""

fin_svg="""

<g id="{0}">
<rect width="{1}" height="60" rx="20" fill="white" stroke="black"   />
<text font-size="12" font-family="arial"  fill="black">
<tspan x="20" y="22" font-weight="bold">
FIN :
</tspan>
<tspan x="20" y="42">
{2}
</tspan>
</text>
</g>

"""

instruction_svg="""

<g id="{0}">
<rect width="{1}"  height="40"  fill="white" stroke="black"   />
<text font-size="12" font-family="arial"  fill="black">
<tspan x="20" y="20">
{2}
</tspan>
</text>
</g>

"""


es_svg="""

<g id="{0}">
<polygon points="40,0 {1},0 {2},40  0,40"  style=" fill:white; stroke:black"/>
<text font-size="12" font-family="arial"  fill="black">
<tspan x="50" y="22" font-weight="bold">
{3}
</tspan>
</text>
</g>

"""


tq_incomplet_svg="""

<g id="{0}">
<g transform="translate ({3})" >
<polygon points="45,0 90,45 45,90 0,45"  style=" fill:white; stroke:black"/>
<text font-size="10" font-family="arial"  fill="black">
<tspan x="20" y="33" font-weight="bold">
TANT QUE
</tspan>
<tspan x="8" y="45" font-weight="bold">
{1}
</tspan>
</text>
<line x1="45" y1="90" x2="45" y2="121" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>
</g>
<use x="60" y="127" xlink:href="#{2}" ></use>
<line x1="{5}" y1="{6}" x2="{5}" y2="{7}" style="stroke:black;stroke-width:2" />
<line x1="{5}" y1="{7}" x2="{8}" y2="{7}" style="stroke:black;stroke-width:2" />
<line x1="{8}" y1="{7}" x2="{8}" y2="45" style="stroke:black;stroke-width:2" />
<line x1="{8}" y1="45" x2="{4}" y2="45" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>


"""

tq_complet_svg="""
<g id="{0}">
<g transform="translate ({3})" patternUnits="userSpaceOnUse">
<polygon points="45,0 90,45 45,90 0,45"  style=" fill:white; stroke:black"/>
<text font-size="10" font-family="arial"  fill="black">
<tspan x="20" y="33" font-weight="bold">
TANT QUE
</tspan>
<tspan x="8" y="45" font-weight="bold">
{1}
</tspan>
</text>
<line x1="45" y1="90" x2="45" y2="121" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>
<circle cx="90" cy="45" r="4" fill="black"/>
<line x1="90" y1="45" x2="{9}" y2="45" style="stroke:black;stroke-width:2" />
<line x1="{9}" y1="45" x2="{9}" y2="{10}" style="stroke:black;stroke-width:2" />
</g>
<use x="60" y="127" xlink:href="#{2}" ></use>
<line x1="{5}" y1="{6}" x2="{5}" y2="{7}" style="stroke:black;stroke-width:2" />
<line x1="{5}" y1="{7}" x2="{8}" y2="{7}" style="stroke:black;stroke-width:2" />
<line x1="{8}" y1="{7}" x2="{8}" y2="45" style="stroke:black;stroke-width:2" />
<line x1="{8}" y1="45" x2="{4}" y2="45" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>



"""


##<circle cx="90" cy="45" r="4" fill="black"/>
##<line x1="90" y1="45" x2="{9}" y2="45" style="stroke:black;stroke-width:2" />
##<line x1="{9}" y1="45" x2="{9}" y2="{5}" style="stroke:black;stroke-width:2" />
##
si_incomplet_svg="""

<g id="{0}">
<g transform="translate ({3})">
<polygon points="45,0 90,45 45,90 0,45"  style=" fill:white; stroke:black"/>
<text font-size="10" font-family="arial"  fill="black">
<tspan x="20" y="33" font-weight="bold">
SI
</tspan>
<tspan x="8" y="45" font-weight="bold">
{1}
</tspan>
</text>
<line x1="45" y1="90" x2="45" y2="121" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>
</g>
<g>
<use x="{4}" y="127" xlink:href="#{2}" ></use>
</g>

"""

si_complet_svg="""

<g id="{0}">

<g transform="translate ({3})">
<polygon points="45,0 90,45 45,90 0,45"  style=" fill:white; stroke:black"/>
<text font-size="10" font-family="arial"  fill="black">
<tspan x="20" y="33" font-weight="bold">
SI
</tspan>
<tspan x="8" y="45" font-weight="bold">
{1}
</tspan>
</text>
<line x1="45" y1="90" x2="45" y2="121" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>
<circle cx="90" cy="45" r="4" fill="black"/>
<line x1="90" y1="45" x2="{5}" y2="45" style="stroke:black;stroke-width:2" />
<line x1="{5}" y1="45" x2="{5}" y2="{9}" style="stroke:black;stroke-width:2" />
<line x1="{5}" y1="{9}" x2="{7}" y2="{9}" style="stroke:black;stroke-width:2" />
<line x1="{7}" y1="{8}" x2="{7}" y2="{9}" style="stroke:black;stroke-width:2" />
</g>
<g>
<use x="{4}" y="127" xlink:href="#{2}"></use>



</g>
"""

si2_svg="""<g id="{0}"><g transform="translate ({8})">

<polygon points="45,0 90,45 45,90  0,45"  style=" fill:white; stroke:black"/>
<text font-size="10" font-family="arial"  fill="black">
<tspan x="38" y="18" font-weight="bold">
SI
</tspan>
<tspan x="4" y="45" font-weight="bold">
{1}
</tspan>
</text>
<line x1="45" y1="90" x2="45" y2="121" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>
<use x="{3}" y="127" xlink:href="#{2}" ></use>


<circle cx="90" cy="45" r="4" fill="black"/>
<line x1="90" y1="45" x2="{4}" y2="45" style="stroke:black;stroke-width:2" marker-end="url(#arrow)"/>
<line x1="{4}" y1="45" x2="{5}" y2="45" style="stroke:black;stroke-width:2" />
<line x1="{5}" y1="45" x2="{5}" y2="121" style="stroke:black;stroke-width:2" marker-end="url(#arrow)" />
<use x="{6}" y="127" xlink:href="#{7}" ></use>

"""
retour_si_svg="""
<g transform="translate ({5})">
<line x1="{0}" y1="{1}" x2="{0}" y2="{4}" style="stroke:black;stroke-width:2" />
<line x1="{2}" y1="{3}" x2="{2}" y2="{4}" style="stroke:black;stroke-width:2" />
<line x1="{0}" y1="{4}" x2="{2}" y2="{4}" style="stroke:black;stroke-width:2" />
</g></g>
"""

debug_text="""
<text font-size="10" font-family="arial"  fill="{0}">
<tspan x="{2}" y="{3}" font-weight="bold">
{1}
</tspan>
</text>"""

class Elements:
    """ elements """
    def __init__(self,id,texte):
        self.id=id
        self.texte=code_html(texte)
   
##        self.x=x
##        self.y=y
##        self.w=0 #width
##        self.h=0 #height
        

    def taille(self):
        return len(self.texte)

class Debut(Elements):
    def __init__(self,id,texte):
        Elements.__init__(self,id,texte)
        self.w=100+5*(len(self.texte)-5) #width
        self.h=60 #height
        self.versx= self.w//2
        self.fromx=self.versx
        self.svg = debut_svg.format(self.id,self.w,self.texte,self.w//2)
        self.type="debut"
        self.fromy=self.h
        
class Fin(Elements):
    def __init__(self,id,texte):
        Elements.__init__(self,id,texte)
        self.w=80+5*(len(self.texte)-4)
        self.h=60
        self.svg = fin_svg.format(self.id,self.w,self.texte,(80+5*(len(self.texte)-4))//2)
        self.versx = self.w//2
        self.fromx=self.versx
        self.type="fin"
        self.fromy=self.h
        
class Instruction(Elements):
    def __init__(self,id,texte):
        Elements.__init__(self,id,texte)
        self.w=8*(len(self.texte))+40
        self.h=40
        self.versx= self.w//2
        self.fromx=self.versx
        self.svg = instruction_svg.format(self.id,self.w,self.texte,self.w//2)
        self.type="instruction"
        self.fromy=self.h
        
class Es(Elements):
      def __init__(self,id,texte):
        Elements.__init__(self,id,texte)
        self.w=8*(len(self.texte))+120
        self.h=40
        self.versx=  self.w//2
        self.fromx=self.versx
        self.svg = es_svg.format(self.id,self.w,self.w-40,self.texte,self.w//2)
        self.type="Entree / Sortie"
        self.fromy=self.h

class Bloc():
    def __init__(self,id,texte,*el):
        self.id=id
        self.texte=texte
        self.el=el
  
        
        vx=0
        translationx=0
        maxtranslationx=0

        
        #premier element
        translationx=0
        chaine='\n<use xlink:href="#{0}" transform="translate({1} {2})"  />'.format(el[0].id,translationx,0)
        svg=chaine
        y=el[0].h
        i=1
        mingauche=0
        maxdroite=el[0].w
        while i<len(el):
            #connecteur
            t1=translationx
            w1=el[i-1].w
            v1=el[i-1].versx
            w2=el[i].w
            f2=el[i].fromx
            translationx+=(-el[i].fromx+el[i-1].versx)
            svg+=connecteur(translationx+el[i].fromx,y)
            y+=36
            chaine='\n<use xlink:href="#{0}" transform="translate({1} {2})"  />'.format(el[i].id,translationx,y)
            mingauche=min(mingauche,translationx)
            maxdroite=max(maxdroite,translationx+el[i].w)
            svg+=chaine
            y+=el[i].h
            
            #element d'indice i
            
                
                
                
            i+=1
        self.w=maxdroite-mingauche
        introsvg='\n <g id="{0}" transform="translate({1})"  >\n'.format(self.id,max(0,-mingauche))
        svg=introsvg+svg+"</g>"
       
        self.versx=el[-1].versx+translationx+max(0,-mingauche)
        self.h=y
        
        self.type="Bloc"
        self.fromx=el[0].fromx+max(0,-mingauche)
        
         #debug
        
##        svg+='<rect width="{0}" height="{1}" x="{2}" y="{3}" rx="0" fill="white" stroke="black" fill-opacity="0"   />'.format(self.w,self.h,0,0)
##        svg+=debug_text.format("black",self.id,-maxtranslationx,0)
##        svg+='<circle cx="{0}" cy="{1}" r="14" fill="green"/>'.format(self.fromx,0) #debug
##        svg+='<circle cx="{0}" cy="{1}" r="14" fill="red" fill-opacity="0.3"/>'.format(self.versx,self.h) #debug
       
        
        self.svg=svg


class Tq():
    def __init__(self,id,texte,flag,objetbloc):
        self.id=id
        self.texte=code_html(texte)
        self.flag=flag  #si True c'est un Tq incomplet
        
        
        self.type="Tant que"
        x=max(objetbloc.versx+30,45)
        y=127+objetbloc.h
             
        
        
        self.h=y+60
        k=15+objetbloc.fromx
        l=15+objetbloc.versx
        self.versx =90+objetbloc.w+k
        self.w=self.versx+1
        self.fromx=45+k
        if flag:
            self.svg=tq_incomplet_svg.format(id,texte,objetbloc.id,k,k-6,45+l,y,y+30,30)
        else:
            self.svg=tq_complet_svg.format(id,texte,objetbloc.id,k,k-6,45+l,y,y+30,30,objetbloc.w+90,y+60)
            
#debug
##        self.svg+='<rect width="{0}" height="{1}" rx="0" fill="white" stroke="red" fill-opacity="0"   />'.format(self.w,self.h)
##        self.svg+=debug_text.format("red",self.id,0,0)
##        self.svg+='<circle cx="{0}" cy="{1}" r="4" fill="blue"/>'.format(x+30,0) #debug
##        self.svg+='<circle cx="{0}" cy="{1}" r="4" fill="orange"/>'.format(self.versx,self.h) #debug
        self.svg+="</g>"
class Si():
    def __init__(self,id,texte,flag,ob):
        self.id=id
        
        self.texte=code_html(texte)
        self.flag=flag  #si True c'est un si incomplet
        bas=127+ob.h
        
        self.type="Si"
        self.h=bas+30
        t=max(ob.fromx-30,0)
        t2=45+t-ob.fromx
        
        g=45-ob.versx
        
        x=max(ob.versx,45)
        f7=45-ob.fromx+ob.versx
        self.w=max(ob.w,90)+t
        if flag:
            self.svg=si_incomplet_svg.format(id,texte,ob.id,t,t2)
        else:
            self.svg=si_complet_svg.format(id,texte,ob.id,t,t2,self.w,bas+30,f7,127+ob.h,127+ob.h+30)
            
        self.versx=45+t+(45+f7)/2
        self.fromx=45+t
        self.w+=60
        #debug
##        self.svg+='<rect x="{2}" width="{0}" height="{1}" rx="0" fill="white" stroke="green" fill-opacity="0"   />'.format(self.w,self.h,x-15)
##        self.svg+=debug_text.format("green",self.id,0,0)
##        self.svg+='<circle cx="{0}" cy="{1}" r="4" fill="blue"/>'.format(self.fromx,0) #debug
##        self.svg+='<circle cx="{0}" cy="{1}" r="4" fill="orange"/>'.format(self.versx,self.h) #debug
        self.svg+="</g>"
class Si2():
    def __init__(self,id,texte,ob1,ob2,flag):
        self.id=id
        self.texte=code_html(texte)
        self.objetbloc1=ob1
        self.objetbloc2=ob2
        self.flag=flag
        t=max(ob2.fromx-30,0)
        droite =max(ob2.w+30,90)
        milieu=(droite)/2+45
        h=max(ob1.h,ob2.h)+150
            
        g=45-ob2.fromx +ob2.versx-t
        d=droite+ob1.versx-ob1.fromx
        
        self.svg=si2_svg.format(id,texte,ob2.id,45-ob2.fromx,milieu,droite,droite-ob1.fromx,ob1.id,t)
        if not flag:
            #retour des deux blocs!
            
            
            self.svg+=retour_si_svg.format(g,ob2.h+127,d-t,ob1.h+127,h,t)
            
            self.h=h
            
        else:
            
            self.h=0
           

        
        self.w=droite+ob1.w+10
        self.fromx=45+t
        self.versx=milieu+t
##        self.svg+='<rect width="{0}" height="{1}" rx="0" fill="white" stroke="green" fill-opacity="0"   />'.format(self.w,self.h)
##        self.svg+=debug_text.format("green",self.id,0,0)
##        self.svg+='<circle cx="{0}" cy="{1}" r="4" fill="blue"/>'.format(self.fromx,0) #debug
##        self.svg+='<circle cx="{0}" cy="{1}" r="4" fill="orange"/>'.format(self.versx,self.h) #debug
        self.svg+="</g>"
        self.type ="Si avec sinon"
        
